# Version 1.0.1 April 23, 2001
#
# This Perl 5 script has been written
# by Marc Muendler and Tiago Ribeiro, University of California, Berkeley, Department of Economics
# e-mails:  muendler@econ.berkeley.edu                tribeiro@econ.berkeley.edu
# URLs:     http://socrates.berkeley.edu/~muendler/   http://idrive.berkeley.edu/~tribeiro/
# 
# Copyright (C) 2001 all rights reserved.
# 
# Copying of this file is authorized only if either
#  (1) you make _no_ changes to your copy, or
#  (2) if you do make any change, you name the altered file differently.
#      (You may keep the file name if you make changes only to 
#       sections that are surrounded by #--- separators.)
#
# Please report bugs (and suggested fixes, if any) to the authors.
# Note: There are two types of inactive print commands in the code:
#            "# print OUT", and 
#            "# @RM[$i]= ", the latter for output in note={} in the BibTeX file.
#       These commands may facilitate debugging when activated.
#

#-----------------------------------------------
# PLEASE ENTER OPTIONS AND FILENAME HERE as $cmd
$cmd = '-e -f -k ucb2';
#-----------------------------------------------

# $cmd Command interpretation
$file= $cmd; $file =~ s/\-\w+\s+//g; 
$ext = $file; $ext =~ s/([\s+\w+\d+\-\.]+)\.//;
if($ext =~ m/\w+/){$ext = 'cgi';}
$file=~ s/\.([\s+\w+\d+\-]+)//;
$option = $cmd; $option =~ s/(\s+)*$file(\s+)*//g; $option =~ s/(\s+)*\.(\s+)*$ext//g;

#-----------------------------------------------------------------------------------------------------------
# CHANGE PATH NAMES for input and output files HERE
open(IN,"<c:/temp/$file.$ext")   or die "Can't open input file $file.$ext. Error ";
open(OUT,">c:/temp/$file.bib")   or die "Can't open output file $file.bib. Error ";
#-----------------------------------------------------------------------------------------------------------

$option =~ s/E/e/g; $option =~ s/F/f/g; $option =~ s/K/k/g; $option =~ s/M/m/g; $option =~ s/Q/q/g; $option =~ s/T/t/g; $option =~ s/V/v/g; # More elegantly
$option =~ s/\-[a-dg-jn-prsuw-zA-Z]//g; 
if($option =~ m/\-l/ && $option =~ m/\-k/){$option =~ s/\s+\-l/ /g;}
$option =~ s/\ \ / /g;
if($option !~ m/\w+/){$optplot = "<none>"}
                else {$optplot=$option}
print OUT '% Input file: '. $file.'.'.$ext . "\n" ;
print OUT '% Options were: '. $optplot . "\n" ;
print OUT '%  -e: Transforms "et al." string into "{et al.}" in author=/editor items (default: no transformation)'. "\n" ;
print OUT '%  -f: Adds a File reference item (set to F) to each BibTeX entry (default: no file reference)'. "\n" ;
print OUT '%  -k: Creates BibTeX Keys from combination of author=/editor= and year= (default: running number; -k overrides -l)'. "\n" ;
print OUT '%  -l: Leaves BibTeX keys out and replaces them by a dummy that causes a BibTeX error (not recommended--default: running number)'. "\n" ;
print OUT '%  -m: Does _not_ transform abbreviated Month names to full names---i.e. _no_ change of "Jan" to "January" etc. (default: transformation)'. "\n" ;
print OUT '%  -q: Changes double Quotes to single Quotes in title= and booktitle= (default: keep double quotes from WebSpirs)'. "\n" ;
print OUT '%  -t: Creates working paper output as TECHREPORT and not as ARTICLE (default: ARTICLE)'. "\n" ;
print OUT '%  -v: Uses volume instead of number for BOOKS and INCOLLECTION items whenever both provided by WebSpirs (default: number)'. "\n" ;
# print OUT '%  (Any further instruction has been ignored.)'. "\n" ;
print OUT "\n" ;

$count=0;
$probljo=0;
$problwp=0;
$problbk=0;
$problph=0;
$problcl=0;
$noprbdt=0;

while(<IN>){

    $_ =~ s/&/\\&/g;          #Replace & for LaTeX;
    $_ =~ s/R\\&D/{R\\&D}/g;  #Replace R&D for LaTeX;
    $_ =~ s/AR\(/{AR}(/g;     #Replace AR(n) for LaTeX;
    $_ =~ s/MA\(/{MA}(/g;     #Replace MA(n) for LaTeX;

    $_ =~ s/\,\-Jr\./ Jr./g;  #Replace "," in front of Jr. for BibTeX;
    $_ =~ s/\,\s+Jr\./ Jr./g; #Replace "," in front of Jr. for BibTeX;

    $_ =~ s/\s+\'/ \`/g;     #Replace correct quotation mark for LaTeX;
    $_ =~ s/\s+\"/ \`\`/g;   #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\s/\'\' /g;    #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\:/\'\':/g;    #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\./\'\'./g;    #Replace correct quotation mark for LaTeX;
    $_ =~ s/\.\"/\'\'/g;     #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\,/\'\',/g;    #Replace correct quotation mark for LaTeX;
    $_ =~ s/\,\"/\'\'/g;     #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\;/\'\';/g;    #Replace correct quotation mark for LaTeX;
    $_ =~ s/\;\"/\'\'/g;     #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\!/\'\'!/g;    #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\?/\'\'?/g;    #Replace correct quotation mark for LaTeX;
    $_ =~ s/\"\-\-/\'\'--/g; #Replace correct quotation mark for LaTeX;

    $_ =~ s/Africa/{A}frica/g; #Replace for LaTeX;
    $_ =~ s/America/{A}merica/g; #Replace for LaTeX;
    $_ =~ s/Asia/{A}sia/g; #Replace for LaTeX;
    $_ =~ s/Australia/{A}ustralia/g; #Replace for LaTeX;
    $_ =~ s/Europe/{E}urope/g; #Replace for LaTeX;
    $_ =~ s/Carribean/{C}arribean/g; #Replace for LaTeX;
    $_ =~ s/Latin/{L}atin/g; #Replace for LaTeX;
    $_ =~ s/Atlantic/{A}tlantic/g; #Replace for LaTeX;
    $_ =~ s/Pacific/{P}acific/g; #Replace for LaTeX;
    $_ =~ s/Indian/{I}ndian/g; #Replace for LaTeX;
    $_ =~ s/Baltic/{B}altic/g; #Replace for LaTeX;
    $_ =~ s/Sahara/{S}ahara/g; #Replace for LaTeX;
    $_ =~ s/EU/{EU}/g; #Replace for LaTeX;
    $_ =~ s/NAFTA/{NAFTA}/g; #Replace for LaTeX;
    $_ =~ s/NATO/{NATO}/g; #Replace for LaTeX;
    $_ =~ s/MERCOSUL/{MERCOSUL}/g; #Replace for LaTeX;
    $_ =~ s/MERCOSUR/{MERCOSUR}/g; #Replace for LaTeX;
    $_ =~ s/North/{N}orth/g; #Replace for LaTeX;
    $_ =~ s/South/{S}outh/g; #Replace for LaTeX;
    $_ =~ s/West/{W}est/g; #Replace for LaTeX;
    $_ =~ s/East/{E}ast/g; #Replace for LaTeX;

    $_ =~ s/Argentin/{A}rgentin/g; #Replace for LaTeX;
    $_ =~ s/Austria/{A}ustria/g; #Replace for LaTeX;
    $_ =~ s/Brazil/{B}razil/g; #Replace for LaTeX;
    $_ =~ s/British/{B}ritish/g; #Replace for LaTeX;
    $_ =~ s/Bulgaria/{B}ulgaria/g; #Replace for LaTeX;
    $_ =~ s/Canad/{C}anad/g; #Replace for LaTeX;
    $_ =~ s/Colombia/{C}olombia/g; #Replace for LaTeX;
    $_ =~ s/Costa\s+Rica/{C}osta {R}ica/g; #Replace for LaTeX;
    $_ =~ s/Chile/{C}hile/g; #Replace for LaTeX;
    $_ =~ s/Chinese/{C}hinese/g; #Replace for LaTeX;
    $_ =~ s/China/{C}hina/g; #Replace for LaTeX;
    $_ =~ s/Cuba/{C}uba/g; #Replace for LaTeX;
    $_ =~ s/Danish/{D}anish/g; #Replace for LaTeX;
    $_ =~ s/Denmark/{D}enmark/g; #Replace for LaTeX;
    $_ =~ s/Dutch/{D}utch/g; #Replace for LaTeX;
    $_ =~ s/Egypt/{E}gypt/g; #Replace for LaTeX;
    $_ =~ s/English/{E}nglish/g; #Replace for LaTeX;
    $_ =~ s/England/{E}ngland/g; #Replace for LaTeX;
    $_ =~ s/French/{F}rench/g; #Replace for LaTeX;
    $_ =~ s/France/{F}rance/g; #Replace for LaTeX;
    $_ =~ s/Finland/{F}inland/g; #Replace for LaTeX;
    $_ =~ s/Finnish/{F}innish/g; #Replace for LaTeX;
    $_ =~ s/German/{G}erman/g; #Replace for LaTeX;
    $_ =~ s/Great Britain/{G}reat {B}ritain/g; #Replace for LaTeX;
    $_ =~ s/Hebrew/{H}ebrew/g; #Replace for LaTeX;
    $_ =~ s/Holland/{H}olland/g; #Replace for LaTeX;
    $_ =~ s/India/{I}ndia/g; #Replace for LaTeX;
    $_ =~ s/Irish/{I}rish/g; #Replace for LaTeX;
    $_ =~ s/Ireland/{I}reland/g; #Replace for LaTeX;
    $_ =~ s/Israel/{I}srael/g; #Replace for LaTeX;
    $_ =~ s/Italian/{I}talian/g; #Replace for LaTeX;
    $_ =~ s/Italy/{I}taly/g; #Replace for LaTeX;
    $_ =~ s/Japan/{J}apan/g; #Replace for LaTeX;
    $_ =~ s/Jew/{J}ew/g; #Replace for LaTeX;
    $_ =~ s/Korea/{K}orea/g; #Replace for LaTeX;
    $_ =~ s/Mexic/{M}exic/g; #Replace for LaTeX;
    $_ =~ s/Morocc/{M}orocc/g; #Replace for LaTeX;
    $_ =~ s/Netherlands/{N}etherlands/g; #Replace for LaTeX;
    $_ =~ s/Niger/{N}iger/g; #Replace for LaTeX;
    $_ =~ s/Norwegian/{N}orwegian/g; #Replace for LaTeX;
    $_ =~ s/Norway/{N}orway/g; #Replace for LaTeX;
    $_ =~ s/Poland/{P}oland/g; #Replace for LaTeX;
    $_ =~ s/Portug/{P}ortug/g; #Replace for LaTeX;
    $_ =~ s/Russia/{R}ussia/g; #Replace for LaTeX;
    $_ =~ s/Scottish/{S}cottish/g; #Replace for LaTeX;
    $_ =~ s/Scotland/{S}cotland/g; #Replace for LaTeX;
    $_ =~ s/Spaniard/{S}paniard/g; #Replace for LaTeX;
    $_ =~ s/Spanish/{S}panish/g; #Replace for LaTeX;
    $_ =~ s/Spain/{S}pain/g; #Replace for LaTeX;
    $_ =~ s/Swedish/{S}wedish/g; #Replace for LaTeX;
    $_ =~ s/Swede/{S}wede/g; #Replace for LaTeX;
    $_ =~ s/Taiwan/{T}aiwan/g; #Replace for LaTeX;
    $_ =~ s/Tunisia/{T}unisia/g; #Replace for LaTeX;
    $_ =~ s/UK/{UK}/g; #Replace UK for LaTeX;
    $_ =~ s/U\.K\./{UK}/g; #Replace UK for LaTeX;
    $_ =~ s/United States/{U}nited {S}tates/g; #Replace US for LaTeX;
    $_ =~ s/US/{US}/g; #Replace US for LaTeX;
    $_ =~ s/U\.S\./{US}/g; #Replace U.S. for LaTeX;
    $_ =~ s/Venezuela/{V}enezuela/g; #Replace for LaTeX;

    $_ =~ s/Calif\./{CA}/g;
    $_ =~ s/Conn\./{CT}/g;
    $_ =~ s/D\.C\./{DC}/g;
    $_ =~ s/\s+DC/ {DC}/g;
    $_ =~ s/Mass\./{MA}/g;
    $_ =~ s/N\.C\./{NC}/g;
    $_ =~ s/N\.D\./{ND}/g;
    $_ =~ s/N\.H\./{NH}/g;
    $_ =~ s/N\.J\./{NJ}/g;
    $_ =~ s/N\.M\./{NM}/g;
    $_ =~ s/N\.Y\./{NY}/g;
    $_ =~ s/Pa\./{PA}/g;
    $_ =~ s/R\.I\./{RI}/g;
    $_ =~ s/S\.C\./{SC}/g;
    $_ =~ s/S\.D\./{SD}/g;
    $_ =~ s/Vt\./{VT}/g;
    $_ =~ s/W\.V\./{WV}/g;

    $_ =~ s/NBER/{NBER}/g;   #Replace capital letters for LaTeX and abbreviate;
    $_ =~ s/National Bureau of Economic Research/{NBER}/g; #Replace for convenience, and mark capital letters for LaTeX and abbreviate;
    $_ =~ s/Keynes/{K}eynes/g;
    $_ =~ s/Microsoft/{M}icrosoft/g;
    $_ =~ s/Ramsey/{R}amsey/g;
    $_ =~ s/Schumpeter/{S}chumpeter/g;

    # Replaces roman volume numbering. Should not replace page numbers since these are comma separated
    $_ =~ s/\s+II\./ 2./g;
    $_ =~ s/\s+III\./ 3./g;
    $_ =~ s/\s+IV\./ 4./g;
    $_ =~ s/\s+V\./ 5./g;
    $_ =~ s/\s+VI\./ 6./g;
    $_ =~ s/\s+VII\./ 7./g;
    $_ =~ s/\s+VIII\./ 8./g;
    $_ =~ s/\s+IX\./ 9./g;
    $_ =~ s/\s+X\./ 10./g;
    $_ =~ s/\s+XI\./ 11./g;
    $_ =~ s/\s+XII\./ 12./g;
    $_ =~ s/\s+ii\./ 2./g;
    $_ =~ s/\s+iii\./ 3\./g;
    $_ =~ s/\s+iv\./ 4./g;
    $_ =~ s/\s+v\./ 5./g;
    $_ =~ s/\s+vi\./ 6./g;
    $_ =~ s/\s+vii\./ 7./g;
    $_ =~ s/\s+viii\./ 8./g;
    $_ =~ s/\s+ix\./ 9./g;
    $_ =~ s/\s+x\./ 10./g;
    $_ =~ s/\s+xi\./ 11./g;
    $_ =~ s/\s+xii\./ 12./g;

    # Avoid Perl confusion when entries contain "St. "
    $_ =~ s/\s+St\.\s+/ StXXX /g;  # will be reset later
       
      if(/TI:/){$count++; 
                $line=$_; $line =~ s/TI:(\s+)// ; $line =~ s/\n// ; $line =~ s/  / /g ; 
                $line =~ s/\[/``/g ; $line =~ s/\]/''/g ; # $line =~ s/\.\b//g ; 
                @TI[$count]= $line ; } 
      if(/AU:/){$line=$_; $line =~ s/AU:(\s+)// ; $line =~ s/\n// ; $line =~ s/-/ /g; $line =~ s/;/ and/g; $line =~ s/\,\s+et\s+al\./ et al./;
                @AU[$count]= $line ; }
      # if(/AF:/){$line=$_; $line =~ s/AF:(\s+)// ; $line =~ s/\n// ; @AF[$count]= $line ; }
      if(/SO:/){$line=$_; $line =~ s/SO:(\s+)// ; $line =~ s/\n// ; @SO[$count]= $line ; }
      if(/FTXT:/){$line=$_; $line =~ s/FTXT:(\s+)// ; $line =~ s/\n// ; @FT[$count]= $line ; }
      if(/DT:/){$line=$_; $line =~ s/DT:(\s+)// ; $line =~ s/\n// ; @DT[$count]= $line ; $noprbdt++ ; }
      if(/PY:/){$line=$_; $line =~ s/PY:(\s+)// ; $line =~ s/\n// ; @PY[$count]= $line ; }
      if(/DP:/){$line=$_; $line =~ s/DP:(\s+)// ; $line =~ s/\n// ; $line =~ s/-/ /g; $line =~ s/;/ and/g; @DP[$count]= $line ; }
      if(/DS:/){$line=$_; $line =~ s/DS:(\s+)// ; $line =~ s/\n// ; $line =~ s/-/ /g; $line =~ s/;/ and/g; @DS[$count]= $line ; }
      # if(/GE:/){$line=$_; $line =~ s/GE:(\s+)// ; $line =~ s/\n// ; @GE[$count]= $line ; }
      if(/AB:/){$line=$_; $line =~ s/AB:(\s+)// ; $line =~ s/\n// ; $line =~ s/  / /g; @AB[$count]= $line ; }
      # if(/AI:/){$line=$_; $line =~ s/AI:(\s+)// ; $line =~ s/\n// ; @AI[$count]= $line ; }
      # if(/UD:/){$line=$_; $line =~ s/UD:(\s+)// ; $line =~ s/\n// ; @UD[$count]= $line ; }
      if(/AV:/){$line=$_; $line =~ s/AV:(\s+)// ; $line =~ s/\n// ; @AV[$count]= $line ; }
      # if(/PR:/){$line=$_; $line =~ s/PR:(\s+)// ; $line =~ s/\n// ; @PR[$count]= $line ; }
      # if(/CR:/){$line=$_; $line =~ s/CR:(\s+)// ; $line =~ s/\n// ; @CR[$count]= $line ; }
      # if(/IS:/){$line=$_; $line =~ s/IS:(\s+)// ; $line =~ s/\n// ; @IS[$count]= $line ; }
      if(/IB:/){$line=$_; $line =~ s/IB:(\s+)// ; $line =~ s/\.// ; $line =~ s/\n// ; @IB[$count]= $line ; }
      # if(/AN:/){$line=$_; $line =~ s/AN:(\s+)// ; $line =~ s/\n// ; @AN[$count]= $line ; }

} # End while loop for read-in

print OUT '% Please note: '. "\n" ;
print OUT '% * Author= or editor= names containing prefixes such as "de", "van", "von", "Jr.", and the like, may need to be adjusted manually using curly brackets.'. "\n" ;
print OUT '%   Please check all INCOLLECTION entries manually. Treatment maybe incomplete due to variation in WebSpirs data.'. "\n" ;
print OUT '% * In particular, you may want to check for subtitles in INCOLLECTION entries. WebSpirs does not allow to distinguish between series and subtitles.'. "\n" ;
print OUT '% * BibTeX does not allow both a volume and a number for a BOOK or an INCOLLECTION item. Choose option [-v] to select'. "\n" ;
print OUT '%   In addition, when books were published in a series, WebSpirs may have erroneously interchanged numbers and volumes, please check.'. "\n" ;
print OUT '% * The keywords= entry only contains JEL numbers (if available). Different classification systems are ignored.'. "\n" ;
print OUT '% * Book-Reviews are suppressed'. "\n" ;
#print OUT '%Please pay close attention to the following In-Collection entries: (some WebSpirs data may have been too different from common patterns to be parsed properly)'. "\n" ; 

for(my $i=1;$i<=$count;$i++){  # Data preparation loops
                               # print OUT "$i\:". @DT[$i] ."  "; # records entries on which some evaluation was performed
    if(@SO[$i] =~ m/\,\s([\d+\w+]+)st\s+edition/ || @SO[$i] =~ m/\,\s([\d+\w+]+)nd\s+edition/ || @SO[$i] =~ m/\,\s([\d+\w+]+)rd\s+edition/ || @SO[$i] =~ m/\,\s([\d+\w+]+)th\s+edition/ || @SO[$i] =~ m/\,\s([\d+\w+]+)st\s+Edition/ || @SO[$i] =~ m/\,\s([\d+\w+]+)nd\s+Edition/ || @SO[$i] =~ m/\,\s([\d+\w+]+)rd\s+Edition/ || @SO[$i] =~ m/\,\s([\d+\w+]+)th\s+Edition/ || @SO[$i] =~ m/\.\s([\d+\w+]+)st\s+edition/ || @SO[$i] =~ m/\.\s([\d+\w+]+)nd\s+edition/ || @SO[$i] =~ m/\.\s([\d+\w+]+)rd\s+edition/ || @SO[$i] =~ m/\.\s([\d+\w+]+)th\s+edition/ || @SO[$i] =~ m/\.\s([\d+\w+]+)st\s+Edition/ || @SO[$i] =~ m/\.\s([\d+\w+]+)nd\s+Edition/ || @SO[$i] =~ m/\.\s([\d+\w+]+)rd\s+Edition/ || @SO[$i] =~ m/\.\s([\d+\w+]+)th\s+Edition/){
              # print OUT "Got an item with recorded edition number. $i\:". @SO[$i] ." \n";
              $_ = @SO[$i];
              /\s+([\w+\d+\-]+)\s+(e*)(E*)dition/;
              @EN[$i]= $1;
              @SO[$i] =~ s/\s+([\w+\d+\-]+)\s+(e*)(E*)dition\.//;
              @SO[$i] =~ s/\s+([\w+\d+\-]+)\s+(e*)(E*)dition\,//;
              @SO[$i] =~ s/\s+([\w+\d+\-]+)\s+(e*)(E*)dition\;//;
              @SO[$i] =~ s/\.\s+([\w+\d+\-]+)\s+(e*)(E*)dition//;
              @SO[$i] =~ s/\,\s+([\w+\d+\-]+)\s+(e*)(E*)dition//;
              @SO[$i] =~ s/\;\s+([\w+\d+\-]+)\s+(e*)(E*)dition//;
              }
    if(@DT[$i] =~ m/Journal-Article/){
              # print OUT "Got an ARTICLE item. $i\:". @SO[$i] ." \n";
              $_ = @SO[$i];    # structure is like "3(1), March 1999, pages 48-68"
              /([\w+\-\{\}]+)\;/;
              $jo = $1; $jo =~ s/-/ /g; $jo =~ s/\{//g; $jo =~ s/\}//g; 
              @JO[$i]= $jo;    
              /\s+([\w+\.\-]+)\s+\d+\,\s+pages\s+(\d+-\d+)\./; 
              @PG[$i]= $2; 
              @MO[$i]= $1;
              /\;\s+(\d+)\(([\d+\-\/]+)\)\,\s/;
              @VO[$i]= $1; 
              @NO[$i]= $2; 
              if(@PG[$i] !~ m/\d+/ || @PG[$i] == @NO[$i]){ /\s+pages\s+(\d+-\d+)/; @PG[$i]= $1; }
              # Special Issue, part 2, Suppl., etc.
              if(@SO[$i] =~ m/\(\d+\)\,\s+([\w+\s+\-]+)\,\s+19\d+\,\s+pages/){   
                               # Structure is like "(12), Special Issue, 1988, pages"
                          /\)\,\s+([\w+\s+\-]+)\,\s+19\d+\,\s+pages/;
                          @RM[$i] = $1;
                          }
              if(@SO[$i] =~ m/\(\d+\)\,\s+([\w+\s+\-]+)\,\s+20\d+\,\s+pages/){   
                               # Structure is like "(10), Special Issue, 2001, pages"
                          /\)\,\s+([\w+\s+\-]+)\,\s+20\d+\,\s+pages/;
                          @RM[$i] = $1;
                          }
              if(@MO[$i] =~ m/\d+/ && @SO[$i] =~ m/\(\d+\)\,\s+([\w+\s+\d+\-\.]+)\s+19\d+\,\s+pages/){   
                               # Structure is like "(0), Suppl. 1 1996, pages"
                          /\)\,\s+([\w+\s+\d+\-\.]+)\s+19\d+\,\s+pages/;
                          @MO[$i] = "";
                          @RM[$i] = $1;
                          }
              if(@MO[$i] =~ m/\d+/ && @SO[$i] =~ m/\(\d+\)\,\s+([\w+\s+\d+\-\.]+)\s+20\d+\,\s+pages/){   
                               # Structure is like "(0), Suppl. 1 2001, pages"
                          /\)\,\s+([\w+\s+\d+\-\.]+)\s+20\d+\,\s+pages/;
                          @MO[$i] = "";
                          @RM[$i] = $1;
                          }
              # @RM[$i] = $_;  # Display remainder of "SO:". Careful, overrides previous settings!
              if(@FT[$i] =~ m/GOTO\(/){ $_ = @FT[$i]; /GOTO\(\d+\,([\w\S\.\:\/\~\&\?+]+)\)/; @SO[$i] = $1; }
                 else                 { $_ = @AV[$i]; @SO[$i] = @AV[$i]; } 
              if(@DP[$i] =~ m/\w+/){ @KW[$i] = @DP[$i]; }
              elsif(@DS[$i] =~ m/\w+/){ $kw = @DS[$i]; $kw =~ s/\(\d+\) //g; $kw =~ s/ \(\d+\)//g; @KW[$i] = $kw; } 
              if(@JO[$i] !~ m/\w+/ || @VO[$i] !~ m/\w+/ || (@PG[$i]==@NO[$i] && @MO[$i]==@VO[$i]) || @MO[$i] =~ m/\d+/){
                $probljo++;
                if($probljo==1){ print OUT "\n" .'%The following @ARTICLE entries may be incomplete or wrong. Please check manually. (This problem is usually due to a non-standard entry in WebSpirs.)'. "\n" ; warn 'There were @ARTICLE entries with problems. See head of output file for details.'. "\n". 'Error occured';}
                print OUT "\%$i\: @AU[$i], @TI[$i] \n";
                }
    }
    elsif(@DT[$i] =~ m/Working-Paper/){
              # print OUT "Got an ARTICLE (Working-Paper) item. $i\:". @SO[$i] ." \n";
              $_ = @SO[$i];  # structure is like "SO:  NBER Working-Paper: 5559, May 1996, pages 40."
              /([a-zA-Z\,\s\{\}\.]+)\:\s+([a-zA-Z0-9\/\-]+)\,\s+(\w+)\s+(\d+)\,\s+pages\s+/;
              @JO[$i]= $1; 
              @PY[$i]= $4; 
              @VO[$i]= $2;
              @MO[$i]= $3;    
              if(@JO[$i] !~ m/\w+/){
                $_ = @SO[$i];  # structure was NOT like "SO:  NBER Working-Paper: 5559, May 1996, pages 40."
                               # try alternatives; one is given below, further alternatives may be needed
                /([a-zA-Z\,\s\{\}\.]+)(\.*)\s+([a-zA-Z0-9\/\-]+)\,\s+(\w+)\s+(\d+)\,\s+pages\s+/;
                $jo= $1;
                @PY[$i]= $5; 
                @VO[$i]= $3;
                @MO[$i]= $4;    
                @JO[$i]= $jo;
                }
              $jo= @JO[$i]; $jo =~ s/\,//g; $jo =~ s/ Series//g; $jo =~ s/ Papers/ Paper/g; $jo =~ s/ papers/ paper/g; @JO[$i]=$jo;
              $vo= @VO[$i]; $vo =~ s/[a-zA-Z]+\///g; $vo =~ s/[a-zA-Z]+\-//g; @VO[$i] = $vo; $vo = "";
              if(@FT[$i] =~ m/GOTO\(/){ $_ = @FT[$i]; /GOTO\(\d+\,([\w\S\.\:\/\~\&\?+]+)\)/; @SO[$i] = $1; }
                 else                 { $_ = @AV[$i]; @SO[$i] = @AV[$i]; } 
              $sr = @SO[$i]; $sr =~ s/Copies available from\:\s//g; $sr =~ s/\{//g; $sr =~ s/\}//g; @SO[$i] = $sr ;
              if(@DP[$i] =~ m/\w+/){ @KW[$i] = @DP[$i]; }
              elsif(@DS[$i] =~ m/\w+/){ $kw = @DS[$i]; $kw =~ s/\(\d+\) //g; $kw =~ s/ \(\d+\)//g; @KW[$i] = $kw; } 
              if($option !~ m/\-t/ && (@JO[$i] !~ m/paper/ || @JO[$i] !~ m/Paper/) ){
                    @JO[$i] = @JO[$i] . ' Working Paper'}
              if(@JO[$i] !~ m/\w+/ || @VO[$i] !~ m/\w+/){
                $problwp++;
                if($problwp==1){ print OUT "\n" .'%The following @ARTICLE (Working-Paper) entries may be incomplete. Please check manually. (This problem is usually due to a non-standard entry in WebSpirs.)'. "\n" ; warn 'There were @ARTICLE (Working-Paper) entries with problems. See head of output file for details.'. "\n". 'Error occured';}
                print OUT "\%$i\: @AU[$i], @TI[$i] \n";
                }
    }
    elsif(@DT[$i] =~ m/Book/ && @DT[$i] !~ m/Book-Review/){
              # print OUT "Got a BOOK. $i\:". @SO[$i] ."  ";
              $_ = @SO[$i];  # structure is like "SO:  Singapore: Institute of Southeast Asian Studies, 2000, pages 313."
              $_ =~ s/\s+/ /g;  # Remove double spaces
              $_ =~ s/\.\./\./g;
              $_ =~ s/\;\s+distrib/. Distrib/g;
              # @RM[$i] = $_;  # Use this line to display SO:
              /([a-zA-Z0-9\,\s\{\}\.\;\-\'\`]+):\s+([a-zA-Z\,\s\{\}\.\-\'\`]+)\,\s/;
              @PB[$i]= $2;
              @AD[$i]= $1;
              if(@AD[$i] =~ m/\. /){ $_ = @AD[$i]; 
                                     /([a-zA-Z0-9\,\s\{\}\.\;\-\'\`]+)\.\s+([a-zA-Z\,\;\s\{\}\.\-\'\`]+)/;
                                     @SETMP[$i]= $1;
                                     @ADTMP[$i]= $2;
                                   }
              if(@ADTMP[$i] !~ m/\w+/ && @AD[$i] =~ m/\, /){ $_ = @AD[$i];  # Add more problem cases here, later
                                     # Split off Washington, {DC} if present (World Bank, IMF, and others reported differently)
                                     $_ =~ s/\,\s+\{/; {/;
                                     if( $_ =~ m/\s+(Washington\; {DC})/){ 
                                     /([a-zA-Z0-9\,\s\{\}\.\;\-\'\`]+)\,\s+(Washington\; {DC})/;
                                     @SETMP[$i]= $1;
                                     @ADTMP[$i]= $2;
                                     # print OUT 'Got a Washington DC entry at '. "$i \n";
                                     }
                                   }
              @ADTMP[$i] =~ s/\; /, /g;
              if(@ADTMP[$i] =~ m/\w+/){ @AD[$i]= @ADTMP[$i]; }
              # @RM[$i] = @ADTMP[$i];  # Use this line to display temporary address entry
              if(@SETMP[$i] =~ m/\w+/){ @SE[$i]= @SETMP[$i]; }
              if(@PB[$i] !~ m/\w+/){
                       /([a-zA-Z0-9\,\s\{\}\.\;\-\'\`]+):\s+([a-zA-Z\,\s\{\}\.\-\'\`]+)\;\s/;
                       @PB[$i]= $2;
                       @AD[$i]= $1; @AD[$i] =~ s/\; /, /g;
                       if(@AD[$i] =~ m/\. /){ $_ = @AD[$i]; 
                                            /([a-zA-Z0-9\,\s\{\}\.\;\-\'\`]+)\.\s+([a-zA-Z\,\s\{\}\.\'\`]+)/;
                                            @SE[$i]= $1;
                                            @AD[$i]= $2; @AD[$i] =~ s/\; /, /g;
                                            }
                                   }
              # @RM[$i] = @PB[$i];  # Use this line to display current publisher entry
              @SO[$i] = @PB[$i];  @SO[$i] =~ s/[a-zA-Z0-9\,\s+\{\}\.\;\-\'\`]+\.\s+Distrib/Distrib/;
              @PB[$i] =~ s/\.\s+Distributed\s+([a-zA-Z\,\;\s\{\}\.\-\'\`]+)//;
              if(@SE[$i] !~ m/\w+/ && @AD[$i] =~ m/\,\s+/){ 
                        @AD[$i] =~ s/\,\s+\{/; {/;
                        # print OUT 'Got a problematic address entry at '. "$i \n";
                        $_ = @AD[$i];
                        /([a-zA-Z0-9\,\s\{\}\.\;\:\-\'\`]+)\,\s+([a-zA-Z\s\-\'\`]+)/;
                        @SE[$i] = $1;
                        @AD[$i] =~ s/([a-zA-Z0-9\,\s\{\}\.\;\:\-\'\`]+)\,\s+//g;
                        }
              @AD[$i] =~ s/\; /, /g;
              @SE[$i] =~ s/\.\. /. /g; @SE[$i] =~ s/\ \ / /g;
              if(@SE[$i] =~ m/Paperback/){@SE[$i]=""}
              if(@SE[$i] =~ m/paperback/){@SE[$i]=""}
              if(@SE[$i] =~ m/Revised edition/){@SE[$i]=""}
              if(@SE[$i] =~ m/revised edition/){@SE[$i]=""}
              if(@SE[$i] =~ m/Vol(s*)\.\s+([\d+\-]+)\,\s+No(s*)\.\s+([\d+\-]+)/ || @SE[$i] =~ m/Vol(s*)\.\s+([\d+\-]+)\,\s+no(s*)\.\s+([\d+\-]+)/ || @SE[$i] =~ m/vol(s*)\.\s+([\d+\-]+)\,\s+No(s*)\.\s+([\d+\-]+)/ || @SE[$i] =~ m/vol(s*)\.\s+([\d+\-]+)\,\s+no(s*)\.\s+([\d+\-]+)/){
                        $_ = @SE[$i];
                        /\w+ol(s*)\.\s+([\d+\-]+)\,\s+\w+o(s*)\.\s+([\d+\-]+)/;
                        @VO[$i] = $2;
                        @NO[$i] = $4;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)(\,|\.)*\s+\w+ol(s*)\.\s+([\d+\-]+)/;
                        @SE[$i]= $1;
                        # print OUT 'Got a volume/number entry at '. "$i \n";
                        }
              elsif(@SE[$i] =~ m/\s+No(s*)\.\s+([\d+\-]+)/ || @SE[$i] =~ m/\s+no(s*)\.\s+([\d+\-]+)/ ){
                        $_ = @SE[$i];
                        /\s+\w+o(s*)\.\s+([\d+\-]+)/;
                        @NO[$i] = $2;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)(\,|\.)*\s+\w+o(s*)\.\s+([\d+\-]+)/;
                        @SE[$i]= $1;
                        # print OUT 'Got a number entry at '. "$i \n";
                        }
              elsif(@SE[$i] =~ m/\s+book\s+([\d+\-]+)/ || @SE[$i] =~ m/\s+Book\s+([\d+\-]+)/){
                        $_ = @SE[$i];
                        /\s+\w+ook\s+([\d+\-]+)/;
                        @NO[$i] = $1;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)(\,|\.)*\s+\w+ook\s+([\d+\-]+)/;
                        @SE[$i]= $1;
                        # print OUT 'Got a book-number entry at '. "$i \n";
                        }
              elsif(@SE[$i] =~ m/\s+part\s+([\d+\-]+)/ || @SE[$i] =~ m/\s+Part\s+([\d+\-]+)/){
                        $_ = @SE[$i];
                        /\s+\w+art\s+([\d+\-]+)/;
                        @NO[$i] = $1;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)(\,|\.)*\s+\w+art\s+([\d+\-]+)/;
                        @SE[$i]= $1;
                        # print OUT 'Got a part-number entry at '. "$i \n";
                        }
              elsif(@SE[$i] =~ m/\s+Vol(s*)\.\s+([\d+\-]+)/ || @SE[$i] =~ m/\s+vol(s*)\.\s+([\d+\-]+)/ ){
                        $_ = @SE[$i];
                        /\s+\w+ol(s*)\.\s+([\d+\-]+)/;
                        @VO[$i] = $2;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)(\,|\.)*\s+\w+ol(s*)\.\s+([\d+\-]+)/;
                        @SE[$i]= $1;
                        # print OUT 'Got a volume entry at '. "$i \n";
                        }
              if(@SE[$i] =~ m/Volume(s*)\s+([\d+\-]+)/ || @SE[$i] =~ m/volume(s*)\s+([\d+\-]+)/ ){
                        $_ = @SE[$i];
                        /olume(s*)\s+([\d+\-]+)/;
                        @VOTMP[$i] = $2;
                        @SE[$i] =~ s/\w+olume(s*)\s+([\d+\-]+)\.\s//; @SE[$i] =~ s/\w+olume(s*)\s+([\d+\-]+)\,\s//;
                        if(@VO[$i] =~ m/\d+/ && @NO[$i] !~ m/d+/){@NO[$i]= @VOTMP[$i]; }
                        else {@VO[$i]= @NO[$i]; @NO[$i]= @VOTMP[$i]; }
                        # print OUT 'Got a volume entry at '. "$i \n";
                        }
              if(@TI[$i] =~ m/\.\s+Volume(s*)\s+([\d+\-]+)/ || @SE[$i] =~ m/\,\s+volume(s*)\s+([\d+\-]+)/ || @SE[$i] =~ m/\;\s+volume(s*)\s+([\d+\-]+)/){
                        $_ = @TI[$i];
                        /olume(s*)\s+([\d+\-]+)/;
                        @VOTMP[$i] = $2;
                        @TI[$i] =~ s/\.\s+Volume(s*)\s+([\d+\-]+)//; @TI[$i] =~ s/\,\s+volume(s*)\s+([\d+\-]+)//; @TI[$i] =~ s/\;\s+volume(s*)\s+([\d+\-]+)//;
                        if(@VO[$i] =~ m/\d+/ && @NO[$i] !~ m/d+/){@NO[$i]= @VOTMP[$i]; }
                        else {@VO[$i]= @NO[$i]; @NO[$i]= @VOTMP[$i]; }
                        # print OUT 'Got a volume entry (from title) at '. "$i \n";
                        }
              @SE[$i] =~ s/(H*)andbooks\s+in\s+(E*)conomics\s+series/Handbooks in Economics/g;
              # @SE[$i] =~ s/\.\s//g;  # Only make leading ". " disappear; Also: make trailing commas disappear
              $se = @SE[$i]; $se =~ s/Volume\s+//g; $se =~ s/volume\s+//g; $se =~ s/Vol\.\s+//g; $se =~ s/vol\.\s+//g; 
                             $se =~ s/Number\s+//g; $se =~ s/number\s+//g; $se =~ s/No\.\s+//g; $se =~ s/no\.\s+//g; 
                             if($se !~ m/([a-zA-Z]+)/){@SE[$i] = ""; }  # remove series if only Volume, etc. contained
              # (source is publisher/distributor) if(@FT[$i] =~ m/GOTO\(/){ $_ = @FT[$i]; /GOTO\(\d+\,([\w\S\.\:\/\~\&\?+]+)\)/; @SO[$i] = $1; }
              # else                 { $_ = @AV[$i]; @SO[$i] = @AV[$i]; } 
              if(@DP[$i] =~ m/\w+/){ @KW[$i] = @DP[$i]; }
              elsif(@DS[$i] =~ m/\w+/){ $kw = @DS[$i]; $kw =~ s/\(\d+\) //g; $kw =~ s/ \(\d+\)//g; @KW[$i] = $kw; } 
              if(@PB[$i] !~ m/\w+/ || @AD[$i] !~ m/\w+/ || (@VO[$i] =~ m/\d+/ && @SE[$i] !~ m/\w+/) || (@NO[$i] =~ m/\d+/ && @SE[$i] !~ m/\w+/)){
                $problbk++;
                if($problbk==1){ print OUT "\n" .'%The following @BOOK entries may be incomplete. Please check manually. (This problem is usually due to a non-standard entry in WebSpirs.)'. "\n" ; warn 'There were @BOOK entries with problems. See head of output file for details.'. "\n". 'Error occured';}
                print OUT "\%$i\: @AU[$i], @TI[$i] \n";
                }
    }
    elsif(@DT[$i] =~ m/Collective-Volume-Article/){
              # print OUT "Got an INCOLLECTION item. $i\:". @SO[$i] ." \n";
              $_ = @SO[$i];  # structure is like "SO:  Wise,-David-A., ed. Inquiries in the economics of aging. NBER Project Report series. Chicago and London: University of Chicago Press, 1998, pages 259-305."
              $_ =~ s/\s+/ /g;   # Remove double spaces
              $_ =~ s/\.\./\./g; # Remove double dots
              $_ =~ s/\;\s+distrib/. Distrib/g;
              /\,\s+pages\s+([\d+\-]+)\./;
              # $_ =~ s/\,\s+pages\s+([\d+\-]+)//; # (possible, but unnecessary adjustment)
              @PG[$i]= $1;
              $_ =~ s/\,\s+ed(s*)\.\;\s+/; /;                        # Remove if "eds." appears more than once
              if($_ !~ m/\,\s+ed(s*)\.\s+/){$_ =~ s/\.\s+/, ed. /;}  # Correct for WebSpirs mistake of missing eds. Incollection entry must have editor
              $_ =~ s/\,\-ed\,\s+ed\./, ed./;                        # Correct for another WebSpirs mistake
              /([a-zA-Z\,\s\.\;\-\`\']+)\,\s+ed(s*)\.\s+([a-zA-Z0-9\,\:\?\s\{\}\(\)\-\'\`]+)\./;
              $ed= $1;
              @BT[$i]= $3;
              $ed =~ s/-/ /g; $ed =~ s/;/ and/g; $ed =~ s/\,\s+et\s+al\./ et al./;
              @ED[$i]= $ed;
              $_ =~ s/([a-zA-Z\,\s\.\;\-\`\']+)\,\s+ed(s*)\.\s+([a-zA-Z0-9\,\:\s\{\}\(\)\-\`\']+)\.\s+//;
              # @RM[$i] = $_;  # Use this line to display remainder
              /([a-zA-Z0-9\,\s\{\}\.\;\-\'\`]+):\s+([a-zA-Z\,\s\{\}\.\-\'\`]+)\,\s/;
              @PB[$i]= $2;
              @AD[$i]= $1;
              if(@AD[$i] =~ m/\. /){ $_ = @AD[$i]; 
                                     /([a-zA-Z0-9\,\s\{\}\.\;\-\'\`]+)\.\s+([a-zA-Z\,\;\s\{\}\.\-\'\`]+)/;
                                     @SETMP[$i]= $1;
                                     @ADTMP[$i]= $2;
                                   }
              if(@ADTMP[$i] !~ m/\w+/ && @AD[$i] =~ m/\, /){ $_ = @AD[$i];  # Add more problem cases here, later
                                     # Split off Washington, {DC} if present (World Bank, IMF, and others reported differently)
                                     $_ =~ s/\,\s+\{/; {/;
                                     if( $_ =~ m/\s+(Washington\; {DC})/){ 
                                     /([a-zA-Z0-9\,\s\{\}\.\;\-\'\`]+)\,\s+(Washington\; {DC})/;
                                     @SETMP[$i]= $1;
                                     @ADTMP[$i]= $2;
                                     # print OUT 'Got a Washington DC entry at '. "$i \n";
                                     }
                                   }
              if(@ADTMP[$i] =~ m/\w+/){ @AD[$i]= @ADTMP[$i]; }
              if(@SETMP[$i] =~ m/\w+/){ @SE[$i]= @SETMP[$i]; }
              if(@PB[$i] !~ m/\w+/){
                       /([a-zA-Z0-9\,\s\{\}\.\;\-]+)\:\s+([a-zA-Z\,\s\{\}\.\-]+)\;\s/;
                       @PB[$i]= $2;
                       @AD[$i]= $1;
                       if(@AD[$i] =~ m/\. /){ $_ = @AD[$i]; 
                                            /([a-zA-Z0-9\,\s\{\}\.\;\-\'\`]+)\.\s+([a-zA-Z\,\s\{\}\.\'\`]+)/;
                                            @SE[$i]= $1;
                                            @AD[$i]= $2;
                                            }
                                   }
              # @RM[$i] = @PB[$i];  # Use this line to display current publisher entry
              @SO[$i] = @PB[$i];  @SO[$i] =~ s/[a-zA-Z0-9\,\s+\{\}\.\;\-\'\`]+\.\s+Distrib/Distrib/;
              @PB[$i] =~ s/\.\s+Distributed\s+([a-zA-Z\,\;\s\{\}\.\-\'\`]+)//;
              if(@SE[$i] !~ m/\w+/ && @AD[$i] =~ m/\,\s+/){ 
                        @AD[$i] =~ s/\,\s+\{/; {/;
                        # print OUT 'Got a problematic address entry at '. "$i \n";
                        $_ = @AD[$i];
                        /([a-zA-Z0-9\,\s\{\}\.\;\:\-\'\`]+)\,\s+([a-zA-Z\s\-\'\`]+)/;
                        @SE[$i] = $1;
                        @AD[$i] =~ s/([a-zA-Z0-9\,\s\{\}\.\;\:\-\'\`]+)\,\s+//g;
                        }
              @AD[$i] =~ s/\; /, /g;
              @SE[$i] =~ s/\.\. /. /g; @SE[$i] =~ s/\ \ / /g; 
              if(@SE[$i] =~ m/Paperback/){@SE[$i]=""}
              if(@SE[$i] =~ m/paperback/){@SE[$i]=""}
              if(@SE[$i] =~ m/Revised edition/){@SE[$i]=""}
              if(@SE[$i] =~ m/revised edition/){@SE[$i]=""}
              if(@SE[$i] =~ m/Vol(s*)\.\s+([\d+\-]+)\,\s+No(s*)\.\s+([\d+\-]+)/ || @SE[$i] =~ m/Vol(s*)\.\s+([\d+\-]+)\,\s+no(s*)\.\s+([\d+\-]+)/ || @SE[$i] =~ m/vol(s*)\.\s+([\d+\-]+)\,\s+No(s*)\.\s+([\d+\-]+)/ || @SE[$i] =~ m/vol(s*)\.\s+([\d+\-]+)\,\s+no(s*)\.\s+([\d+\-]+)/){
                        $_ = @SE[$i];
                        /\w+ol(s*)\.\s+([\d+\-]+)\,\s+\w+o(s*)\.\s+([\d+\-]+)/;
                        @VO[$i] = $2;
                        @NO[$i] = $4;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)(\,|\.)*\s+\w+ol(s*)\.\s+([\d+\-]+)/;
                        @SE[$i]= $1;
                        # print OUT 'Got a volume/number entry at '. "$i \n";
                        }
              elsif(@SE[$i] =~ m/\s+No(s*)\.\s+([\d+\-]+)/ || @SE[$i] =~ m/\s+no(s*)\.\s+([\d+\-]+)/ ){
                        $_ = @SE[$i];
                        /\s+\w+o(s*)\.\s+([\d+\-]+)/;
                        @NO[$i] = $2;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)(\,|\.)*\s+\w+o(s*)\.\s+([\d+\-]+)/;
                        @SE[$i]= $1;
                        # print OUT 'Got a number entry at '. "$i \n";
                        }
              elsif(@SE[$i] =~ m/\s+book\s+([\d+\-]+)/ || @SE[$i] =~ m/\s+Book\s+([\d+\-]+)/){
                        $_ = @SE[$i];
                        /\s+\w+ook\s+([\d+\-]+)/;
                        @NO[$i] = $1;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)(\,|\.)*\s+\w+ook\s+([\d+\-]+)/;
                        @SE[$i]= $1;
                        # print OUT 'Got a book-number entry at '. "$i \n";
                        }
              elsif(@SE[$i] =~ m/\s+part\s+([\d+\-]+)/ || @SE[$i] =~ m/\s+Part\s+([\d+\-]+)/){
                        $_ = @SE[$i];
                        /\s+\w+art\s+([\d+\-]+)/;
                        @NO[$i] = $1;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)(\,|\.)*\s+\w+art\s+([\d+\-]+)/;
                        @SE[$i]= $1;
                        # print OUT 'Got a part-number entry at '. "$i \n";
                        }
              elsif(@SE[$i] =~ m/\s+Vol(s*)\.\s+([\d+\-]+)/ || @SE[$i] =~ m/\s+vol(s*)\.\s+([\d+\-]+)/ ){
                        $_ = @SE[$i];
                        /\s+\w+ol(s*)\.\s+([\d+\-]+)/;
                        @VO[$i] = $2;
                        /([a-zA-Z0-9\,\s\{\}\.\;\-]+)(\,|\.)*\s+\w+ol(s*)\.\s+([\d+\-]+)/;
                        @SE[$i]= $1;
                        # print OUT 'Got a volume entry at '. "$i \n";
                        }
              if(@SE[$i] =~ m/Volume(s*)\s+([\d+\-]+)/ || @SE[$i] =~ m/volume(s*)\s+([\d+\-]+)/ ){
                        $_ = @SE[$i];
                        /olume(s*)\s+([\d+\-]+)/;
                        @VOTMP[$i] = $2;
                        @SE[$i] =~ s/\w+olume(s*)\s+([\d+\-]+)\.\s//; @SE[$i] =~ s/\w+olume(s*)\s+([\d+\-]+)\,\s//;
                        if(@VO[$i] =~ m/\d+/ && @NO[$i] !~ m/d+/){@NO[$i]= @VOTMP[$i]; }
                        else {@VO[$i]= @NO[$i]; @NO[$i]= @VOTMP[$i]; }
                        # print OUT 'Got a volume entry at '. "$i \n";
                        }
              if(@TI[$i] =~ m/\.\s+Volume(s*)\s+([\d+\-]+)/ || @SE[$i] =~ m/\,\s+volume(s*)\s+([\d+\-]+)/ || @SE[$i] =~ m/\;\s+volume(s*)\s+([\d+\-]+)/){
                        $_ = @TI[$i];
                        /olume(s*)\s+([\d+\-]+)/;
                        @VOTMP[$i] = $2;
                        @TI[$i] =~ s/\.\s+Volume(s*)\s+([\d+\-]+)//; @TI[$i] =~ s/\,\s+volume(s*)\s+([\d+\-]+)//; @TI[$i] =~ s/\;\s+volume(s*)\s+([\d+\-]+)//;
                        if(@VO[$i] =~ m/\d+/ && @NO[$i] !~ m/d+/){@NO[$i]= @VOTMP[$i]; }
                        else {@VO[$i]= @NO[$i]; @NO[$i]= @VOTMP[$i]; }
                        # print OUT 'Got a volume entry (from title) at '. "$i \n";
                        }
              @SE[$i] =~ s/(H*)andbooks\s+in\s+(E*)conomics\s+series/Handbooks in Economics/g;
              # @SE[$i] =~ s/\.\s//g;  # Only make leading ". " disappear; Also: make trailing commas disappear
              $se = @SE[$i]; $se =~ s/Volume\s+//g; $se =~ s/volume\s+//g; $se =~ s/Vol\.\s+//g; $se =~ s/vol\.\s+//g; 
                             $se =~ s/Number\s+//g; $se =~ s/number\s+//g; $se =~ s/No\.\s+//g; $se =~ s/no\.\s+//g; 
                             if($se !~ m/([a-zA-Z]+)/){@SE[$i] = ""; }  # remove series if only Volume, etc. contained
              # (source determined through publisher/distributor) if(@FT[$i] =~ m/GOTO\(/){ $_ = @FT[$i]; /GOTO\(\d+\,([\w\S\.\:\/\~\&\?+]+)\)/; @SO[$i] = $1; }
              # else                 { $_ = @AV[$i]; @SO[$i] = @AV[$i]; } 
              if(@DP[$i] =~ m/\w+/){ @KW[$i] = @DP[$i]; }
              elsif(@DS[$i] =~ m/\w+/){ $kw = @DS[$i]; $kw =~ s/\(\d+\) //g; $kw =~ s/ \(\d+\)//g; @KW[$i] = $kw; } 
              if(@PG[$i] !~ m/\d+/ || @BT[$i] !~ m/\w+/ || @ED[$i] !~ m/\w+/ || @PB[$i] !~ m/\w+/ || @AD[$i] !~ m/\w+/ || (@VO[$i] =~ m/\d+/ && @SE[$i] !~ m/\w+/)){
                $problcl++;
                if($problcl==1){ print OUT "\n" .'%The following @INCOLLECTION entries may be incomplete. Please check manually. (This problem is usually due to a non-standard entry in WebSpirs.)'. "\n" ; warn 'There were @INCOLLECTION entries with problems. See head of output file for details.'. "\n". 'Error occured';}
                print OUT "\%$i\: @AU[$i], @TI[$i] \n";
                }
    }
    elsif(@DT[$i] =~ m/Dissertation/){
              # print OUT "Got a PHDTHESIS. $i\:". @SO[$i] ." \n";
              $_ = @SO[$i];    # structure is like "University of Pennsylvania, Ph.D. 1998"
              /([\w+\s+\{\}]+)\,\s+Ph\.D\.\s+\d+/;
              @SC[$i]=$1 ;
              if(@DP[$i] =~ m/\w+/){ @KW[$i] = @DP[$i]; }
              elsif(@DS[$i] =~ m/\w+/){ $kw = @DS[$i]; $kw =~ s/\(\d+\) //g; $kw =~ s/ \(\d+\)//g; @KW[$i] = $kw; } 
              if(@SC[$i] !~ m/\w+/){
                $problph++;
                if($problph==1){ print OUT "\n" .'%The following @PHDTHESIS entries may be incomplete. Please check manually. (This problem is usually due to a non-standard entry in WebSpirs.)'. "\n" ; warn 'There were @PHDTHESIS entries with problems. See head of output file for details.'. "\n". 'Error occured';}
                print OUT "\%$i\: @AU[$i], @TI[$i] \n";
                }
    }
    
# Some After-Treatments

# Reset volume and number entries to avoid BibTeX errors for Collective-Volume-Articles (loosing information here)
if((@DT[$i] =~ m/Collective-Volume-Article/ || @DT[$i] =~ m/Book/) && @NO[$i] =~ m/\d+/ && @SE[$i] !~ m/\w+/){@VO[$i] = @NO[$i]; @NO[$i] = "";}  
if((@DT[$i] =~ m/Collective-Volume-Article/ || @DT[$i] =~ m/Book/) && @NO[$i] =~ m/\d+/ && @VO[$i] =~ m/\d+/){
    if($option =~ m/\-v/){@NO[$i] = ""}
    else                 {@VO[$i] = ""}
    }  
if(@JO[$i] =~ m/Brookings Papers/){
    if(@NO[$i] =~ m/0/){@NO[$i] = ""}
    if(@VO[$i] =~ m/0/ && @NO[$i] =~ m/\d+/){@VO[$i] = @PY[$i]}
        else                                {@VO[$i] = ""}
    }

# Remove colliding interpunctuation, and other adjustments
@TI[$i] =~ s/\?\:/?/g; @TI[$i] =~ s/\?\./?/g;
@AB[$i] =~ s/\?\:/?/g; @AB[$i] =~ s/\?\./?/g;
@KW[$i] =~ s/\?\:/?/g; @KW[$i] =~ s/\?\./?/g;
@BT[$i] =~ s/\?\:/?/g; @BT[$i] =~ s/\?\./?/g;
@TI[$i] =~ s/\.\'/'/g; @BT[$i] =~ s/\.\'/'/g; @TI[$i] =~ s/\.\'\'/''/g; @BT[$i] =~ s/\.\'\'/''/g;  # Only at end of string
@TI[$i] =~ s/\,\'/'/g; @BT[$i] =~ s/\,\'/'/g; @TI[$i] =~ s/\,\'\'/''/g; @BT[$i] =~ s/\,\'\'/''/g;  # Only at end of string
@TI[$i] =~ s/\;\'/'/g; @BT[$i] =~ s/\;\'/'/g; @TI[$i] =~ s/\;\'\'/''/g; @BT[$i] =~ s/\;\'\'/''/g;  # Only at end of string
if($option =~ m/\-q/){@TI[$i] =~ s/\'\'/'/g; @TI[$i] =~ s/\`\`/`/g; @BT[$i] =~ s/\'\'/'/g; @BT[$i] =~ s/\`\`/`/g; }
 
# Get "et al." citations right for BibTeX styles with full first names
if($option =~ m/\-e/){
@AU[$i] =~ s/\s+et\s+al\./ {et al.}/; 
@ED[$i] =~ s/\s+et\s+al\./ {et al.}/; 
}

# Reset "StXXX" to original "St." (possible confusion is over)
@AU[$i] =~ s/StXXX/St./g;
@TI[$i] =~ s/StXXX/St./g;
@JO[$i] =~ s/StXXX/St./g;
@PY[$i] =~ s/StXXX/St./g;
@VO[$i] =~ s/StXXX/St./g;
@NO[$i] =~ s/StXXX/St./g;
@PG[$i] =~ s/StXXX/St./g;
@MO[$i] =~ s/StXXX/St./g;
@RM[$i] =~ s/StXXX/St./g;
@AB[$i] =~ s/StXXX/St./g;
@KW[$i] =~ s/StXXX/St./g;
@SO[$i] =~ s/StXXX/St./g;
@BT[$i] =~ s/StXXX/St./g;
@PB[$i] =~ s/StXXX/St./g;
@ED[$i] =~ s/StXXX/St./g;
@SE[$i] =~ s/StXXX/St./g;
@TY[$i] =~ s/StXXX/St./g;
@CH[$i] =~ s/StXXX/St./g;
@AD[$i] =~ s/StXXX/St./g;
@EN[$i] =~ s/StXXX/St./g;
@IB[$i] =~ s/StXXX/St./g;
@SC[$i] =~ s/StXXX/St./g;

$mt = @MO[$i]; $mt =~ s/\.//g; $mt =~ s/\//\-/g; 
if($option !~ m/\-m/){  # Do not perform month correction if option -m was set
if($mt =~ m/Jan/ && $mt !~ m/Janu/){$mt =~ s/Jan/January/g;}
if($mt =~ m/Feb/ && $mt !~ m/Febr/){$mt =~ s/Feb/February/g;}
if($mt =~ m/Mar/ && $mt !~ m/Marc/){$mt =~ s/Mar/March/g;}
if($mt =~ m/Apr/ && $mt !~ m/Apri/){$mt =~ s/Apr/April/g;}
if($mt =~ m/Jun/ && $mt !~ m/June/){$mt =~ s/Jun/June/g;}
if($mt =~ m/Jul/ && $mt !~ m/July/){$mt =~ s/Jul/July/g;}
if($mt =~ m/Aug/ && $mt !~ m/Augu/){$mt =~ s/Aug/August/g;}
if($mt =~ m/Sep/ && $mt !~ m/Sept/){$mt =~ s/Sep/September/g;}
if($mt =~ m/Oct/ && $mt !~ m/Octo/){$mt =~ s/Oct/October/g;}
if($mt =~ m/Nov/ && $mt !~ m/Nove/){$mt =~ s/Nov/November/g;}
if($mt =~ m/Dec/ && $mt !~ m/Dece/){$mt =~ s/Dec/December/g;}
}
@MO[$i] = $mt;
$nm = @NO[$i]; $nm =~ s/\//\-/g; @NO[$i] = $nm;
# $vo = @VO[$i]; $vo =~ s/\//\\\//g; @VO[$i] = $vo;
if(@SO[$i] =~ m/@PB[$i]/){@SO[$i]="";}  # Avoids error of repeating publisher in source

} # End data preparation loops


# Create different BibTeX keys if option [-k] is set
if($option =~ m/\-k/){
    for(my $i=$count;$i>=1;$i--){
      if(@DT[$i] =~ m/Collective-Volume-Article/){$_ = @ED[$i];}
      else                                       {$_ = @AU[$i];}
      /\s+and\s+([\w+\-\`\']+)\,([\s+\w+\-\`\'\.]+)\s+and\s+([\w+\-\`\']+)\,/;
      $au3 = $3;
      /\s+and\s+([\w+\-\`\']+)\,/;
      $au2 = $1;
      /([\w+\-\`\']+)\,/;
      $au1 = $1;
      if($au3 =~ m/\w+/){
          if($au3 =~ m/(\w\w\w\w\w)/){$_ = $au3; /(\w\w\w\w\w)/; $au3 = $1;}
          if($au2 =~ m/(\w\w\w\w\w)/){$_ = $au2; /(\w\w\w\w\w)/; $au2 = $1;}
          if($au1 =~ m/(\w\w\w\w\w)/){$_ = $au1; /(\w\w\w\w\w)/; $au1 = $1;}
      }
      else {
          if($au2 =~ m/(\w\w\w\w\w\w)/){$_ = $au2; /(\w\w\w\w\w\w)/; $au2 = $1;}
          if($au1 =~ m/(\w\w\w\w\w\w)/){$_ = $au1; /(\w\w\w\w\w\w)/; $au1 = $1;}
      }
      $yr = @PY[$i]-1900; if($yr>99){$yr=$yr-100}; if($yr<10){$yr="0".$yr}; 
      @BIBKEY[$i]=$au1.$au2.$au3.$yr;
      if(@DT[$i] =~ m/Collective-Volume-Article/){@BIBKEY[$i]= @BIBKEY[$i].":"; @BIBREP[$i]=1;}
      for(my $j=$count;$j>=$i+1;$j--){
         if(@BIBKEY[$j] =~ m/@BIBKEY[$i]/ && @BIBKEY[$i] =~ m/@BIBKEY[$j]/){  # Two entries coincide
            @BIBREP[$j]++; if(@BIBREP[$j]<2){@BIBREP[$j]=2}
            @BIBREP[$i]=1;
         }
      }
    }
    for(my $i=1;$i<=$count;$i++){  
      if(@BIBREP[$i]>0){
       if(@DT[$i] =~ m/Collective-Volume-Article/){@BIBKEY[$i] = @BIBKEY[$i].@BIBREP[$i];}
       else{  # If not In-Collection item, replace numbers by letters whenever number less than 25
        @BIBREP[$i] =~ s/25/z/g; @BIBREP[$i] =~ s/24/y/g; @BIBREP[$i] =~ s/23/x/g; @BIBREP[$i] =~ s/22/w/g; @BIBREP[$i] =~ s/21/v/g;
        @BIBREP[$i] =~ s/20/u/g; @BIBREP[$i] =~ s/19/t/g; @BIBREP[$i] =~ s/18/s/g; @BIBREP[$i] =~ s/17/r/g;  @BIBREP[$i] =~ s/16/q/g; @BIBREP[$i] =~ s/15/p/g; @BIBREP[$i] =~ s/14/o/g; @BIBREP[$i] =~ s/13/n/g; @BIBREP[$i] =~ s/12/m/g; @BIBREP[$i] =~ s/11/l/g;
        @BIBREP[$i] =~ s/10/k/g; @BIBREP[$i] =~  s/9/j/g; @BIBREP[$i] =~  s/8/h/g; @BIBREP[$i] =~  s/7/g/g;  @BIBREP[$i] =~  s/6/f/g; @BIBREP[$i] =~  s/5/e/g; @BIBREP[$i] =~  s/4/d/g; @BIBREP[$i] =~  s/3/c/g; @BIBREP[$i] =~  s/2/b/g; @BIBREP[$i] =~  s/1/a/g; 
        @BIBKEY[$i] = @BIBKEY[$i].'-'.@BIBREP[$i];
       }}
    }
}


print OUT "\n\n" ;


for(my $i=1;$i<=$count;$i++){  # Write to output file

if(@DT[$i] =~ m/Journal-Article/){
  if($option =~ m/\-l/)   {print OUT '@ARTICLE{,'. "\n" ;}
  elsif($option =~ m/\-k/){print OUT '@ARTICLE{'.@BIBKEY[$i].','. "\n" ;}
  else                    {print OUT '@ARTICLE{'.$i.','. "\n" ;}
  print OUT 'author =       {' . @AU[$i] . '},' . "\n";
  print OUT 'title =        {' . @TI[$i] . '},' . "\n";
  print OUT 'journal =      {' . @JO[$i] . '},' . "\n";
  print OUT 'year =         {' . @PY[$i] . '},' . "\n";
  print OUT 'volume =       {' . @VO[$i] . '},' . "\n";
  print OUT 'number =       {' . @NO[$i] . '},' . "\n";
  print OUT 'pages =        {' . @PG[$i] . '},' . "\n";
  print OUT 'month =        {' . @MO[$i] . '},' . "\n";
  print OUT 'note =         {' . @RM[$i] . '},' . "\n";
  print OUT 'abstract =     {' . @AB[$i] . '},' . "\n";
  print OUT 'keywords =     {' . @KW[$i] . '},' . "\n";
  print OUT 'source =       {' . @SO[$i] . '},' . "\n";
  if($option =~ m/\-f/){print OUT 'file = F'."\n";}
  print OUT '}'."\n\n";
  }

elsif(@DT[$i] =~ m/Working-Paper/){
  if($option =~ m/\-t/){
  @JO[$i] =~ s/\s+Working\s+Paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\,\s+([a-zA-Z\-\'\`]+)(\,*)\s+and\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+Discussion\s+Paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\,\s+([a-zA-Z\-\'\`]+)(\,*)\s+and\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+working\s+paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\,\s+([a-zA-Z\-\'\`]+)(\,*)\s+and\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+discussion\s+paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\,\s+([a-zA-Z\-\'\`]+)(\,*)\s+and\s+([a-zA-Z\-\'\`]+)//g; 
  @JO[$i] =~ s/\s+Working\s+Paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\s+and\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+Discussion\s+Paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\s+and\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+working\s+paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\s+and\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+discussion\s+paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)\s+and\s+([a-zA-Z\-\'\`]+)//g; 
  @JO[$i] =~ s/\s+Working\s+Paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+Discussion\s+Paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+working\s+paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)//g; @JO[$i] =~ s/\s+discussion\s+paper(s*)\s+in\s+([a-zA-Z\-\'\`]+)//g; 
  @JO[$i] =~ s/\s+Working\s+Paper(s*)//g; @JO[$i] =~ s/\s+Discussion\s+Paper(s*)//g; @JO[$i] =~ s/\s+working\s+paper(s*)//g; @JO[$i] =~ s/\s+discussion\s+paper(s*)//g; 
# (avoid confusion; some institutions have both working papers and technical papers; see NBER) @JO[$i] =~ s/\s+Technical\s+Report(s*)//g; @JO[$i] =~ s/\s+technical\s+report(s*)//g; 
# (avoid confusion; some institutions have both working papers and technical papers; see NBER) @JO[$i] =~ s/\s+Technical\s+Paper(s*)//g; @JO[$i] =~ s/\s+technical\s+paper(s*)//g; 
  @JO[$i] =~ s/\s+series\s+in\s+([a-zA-Z\-\'\`]+)//g;   @JO[$i] =~ s/\s+Series\s+in\s+([a-zA-Z\-\'\`]+)//g; 
  @JO[$i] =~ s/\s+series//g;   @JO[$i] =~ s/\s+Series//g; 
  if($option =~ m/\-l/)   {print OUT '@TECHREPORT{,'. "\n" ;}
  elsif($option =~ m/\-k/){print OUT '@TECHREPORT{'.@BIBKEY[$i].','. "\n" ;}
  else                    {print OUT '@TECHREPORT{'.$i.','. "\n" ;}
  print OUT 'author =       {' . @AU[$i] . '},' . "\n";
  print OUT 'title =        {' . @TI[$i] . '},' . "\n";
  print OUT 'institution =  {' . @JO[$i] . '},' . "\n";
  print OUT 'address =      {' . @AD[$i] . '},' . "\n";
  print OUT 'year =         {' . @PY[$i] . '},' . "\n";
  print OUT 'month =        {' . @MO[$i] . '},' . "\n";
  print OUT 'type =         {' . @TY[$i] . '},' . "\n";
  print OUT 'number =       {' . @VO[$i] . '},' . "\n";
  print OUT 'note =         {' . @RM[$i] . '},' . "\n";
  print OUT 'abstract =     {' . @AB[$i] . '},' . "\n";
  print OUT 'keywords =     {' . @KW[$i] . '},' . "\n";
  print OUT 'source =       {' . @SO[$i] . '},' . "\n";
  if($option =~ m/\-f/){print OUT 'file = F'."\n";}
  print OUT '}'."\n\n";
   }
  else {
  if($option =~ m/\-l/)   {print OUT '@ARTICLE{,'. "\n" ;}
  elsif($option =~ m/\-k/){print OUT '@ARTICLE{'.@BIBKEY[$i].','. "\n" ;}
  else                    {print OUT '@ARTICLE{'.$i.','. "\n" ;}
  print OUT 'author =       {' . @AU[$i] . '},' . "\n";
  print OUT 'title =        {' . @TI[$i] . '},' . "\n";
  print OUT 'journal =      {' . @JO[$i] . '},' . "\n";
  print OUT 'note =         {' . @RM[$i] . '},' . "\n";
  print OUT 'year =         {' . @PY[$i] . '},' . "\n";
  print OUT 'volume =       {' . @VO[$i] . '},' . "\n";
  print OUT 'month =        {' . @MO[$i] . '},' . "\n";
  print OUT 'abstract =     {' . @AB[$i] . '},' . "\n";
  print OUT 'keywords =     {' . @KW[$i] . '},' . "\n";
  print OUT 'source =       {' . @SO[$i] . '},' . "\n";
  if($option =~ m/\-f/){print OUT 'file = F'."\n";}
  print OUT '}'."\n\n";
  }
  }

elsif(@DT[$i] =~ m/Collective-Volume-Article/){
  if($option =~ m/\-l/)   {print OUT '@INCOLLECTION{,'. "\n" ;}
  elsif($option =~ m/\-k/){print OUT '@INCOLLECTION{'.@BIBKEY[$i].','. "\n" ;}
  else                    {print OUT '@INCOLLECTION{'.$i.','. "\n" ;}
  print OUT 'author =       {' . @AU[$i] . '},' . "\n";
  print OUT 'title =        {' . @TI[$i] . '},' . "\n";
  print OUT 'pages =        {' . @PG[$i] . '},' . "\n";
  print OUT 'booktitle =    {' . @BT[$i] . '},' . "\n";
  print OUT 'publisher =    {' . @PB[$i] . '},' . "\n";
  print OUT 'year =         {' . @PY[$i] . '},' . "\n";
  print OUT 'editor =       {' . @ED[$i] . '},' . "\n";
  print OUT 'volume =       {' . @VO[$i] . '},' . "\n";
  print OUT 'number =       {' . @NO[$i] . '},' . "\n";
  print OUT 'series =       {' . @SE[$i] . '},' . "\n";
  print OUT 'type =         {' . @TY[$i] . '},' . "\n";
  print OUT 'chapter =      {' . @CH[$i] . '},' . "\n";
  print OUT 'address =      {' . @AD[$i] . '},' . "\n";
  print OUT 'edition =      {' . @EN[$i] . '},' . "\n";
  print OUT 'month =        {' . @MO[$i] . '},' . "\n";
  print OUT 'note =         {' . @RM[$i] . '},' . "\n";
  print OUT 'isdn =         {' . @IB[$i] . '},' . "\n";
  print OUT 'abstract =     {' . @AB[$i] . '},' . "\n";
  print OUT 'keywords =     {' . @KW[$i] . '},' . "\n";
  print OUT 'source =       {' . @SO[$i] . '},' . "\n";
  if($option =~ m/\-f/){print OUT 'file = F'."\n";}
  print OUT '}'."\n\n";
  }

elsif(@DT[$i] =~ m/Book/ && @DT[$i] !~ m/Book-Review/){
  if($option =~ m/\-l/)   {print OUT '@BOOK{,'. "\n" ;}
  elsif($option =~ m/\-k/){print OUT '@BOOK{'.@BIBKEY[$i].','. "\n" ;}
  else                    {print OUT '@BOOK{'.$i.','. "\n" ;}
  if(@AU[$i] =~ m/\,\s+ed(s*)\./ || @AU[$i] =~ m/\,\s+Ed(s*)\./){ 
        $_ = @AU[$i];
        # print OUT 'Got an editor '. "$i \n";
        /([a-zA-Z\,\s\{\}\.\-]+)\,\s+\w+d(s*)\./;
        $ed = $1;
        print OUT 'editor =       {' . $ed     . '},' . "\n";}
  else{ print OUT 'author =       {' . @AU[$i] . '},' . "\n";}
  print OUT 'title =        {' . @TI[$i] . '},' . "\n";
  print OUT 'publisher =    {' . @PB[$i] . '},' . "\n";
  print OUT 'year =         {' . @PY[$i] . '},' . "\n";
  print OUT 'volume =       {' . @VO[$i] . '},' . "\n";
  print OUT 'number =       {' . @NO[$i] . '},' . "\n";
  print OUT 'series =       {' . @SE[$i] . '},' . "\n";
  print OUT 'address =      {' . @AD[$i] . '},' . "\n";
  print OUT 'edition =      {' . @EN[$i] . '},' . "\n";
  print OUT 'month =        {' . @MO[$i] . '},' . "\n";
  print OUT 'note =         {' . @RM[$i] . '},' . "\n";
  print OUT 'isdn =         {' . @IB[$i] . '},' . "\n";
  print OUT 'abstract =     {' . @AB[$i] . '},' . "\n";
  print OUT 'keywords =     {' . @KW[$i] . '},' . "\n";
  print OUT 'source =       {' . @SO[$i] . '},' . "\n";
  if($option =~ m/\-f/){print OUT 'file = F'."\n";}
  print OUT '}'."\n\n";
  }

elsif(@DT[$i] =~ m/Dissertation/){
  if($option =~ m/\-l/)   {print OUT '@PHDTHESIS{,'. "\n" ;}
  elsif($option =~ m/\-k/){print OUT '@PHDTHESIS{'.@BIBKEY[$i].','. "\n" ;}
  else                    {print OUT '@PHDTHESIS{'.$i.','. "\n" ;}
  print OUT 'author =       {' . @AU[$i] . '},' . "\n";
  print OUT 'title =        {' . @TI[$i] . '},' . "\n";
  print OUT 'school =       {' . @SC[$i] . '},' . "\n";
  print OUT 'year =         {' . @PY[$i] . '},' . "\n";
  print OUT 'type =         {' . @TP[$i] . '},' . "\n";
  print OUT 'address =      {' . @JO[$i] . '},' . "\n";
  print OUT 'month =        {' . @MO[$i] . '},' . "\n";
  print OUT 'note =         {' . @RM[$i] . '},' . "\n";
  print OUT 'abstract =     {' . @AB[$i] . '},' . "\n";
  print OUT 'keywords =     {' . @KW[$i] . '},' . "\n";
  print OUT 'source =       {' . @SO[$i] . '},' . "\n";
  if($option =~ m/\-f/){print OUT 'file = F'."\n";}
  print OUT '}'."\n\n";
  }

} # End for() loop for printing

if($noprbdt==0){print OUT "\n" .'%The WebSpirs .cgi file did not contain any DT: entry. The current output file may be useless.'. "\n" ; warn 'The WebSpirs .cgi file did not contain any DT: entry. Output may  be useless.'. "\n". 'Error occured';}
